%define ALD_Ver		1.2.4
%define X11_Version	7.7
%define X11_Release	4
%define USE_ProtoBinDir 1


Name:         mesa-glew
Version:      1.10.0
Release:      1

License:      LGPL
Summary:      The OpenGL Extension Wrangler library
Group:        Development/Libraries

Source: %{name}-%{version}.tar.xz
Source1: CROSS-X11.sh
Source2: %{name}-%{version}-patches.tgz

%define DestDir		/X11/%{X11_Version}-%{X11_Release}
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%define _prefix /usr/X11R%{X11_Version}
%define _libdir	%{_prefix}/%{_lib}
%if %{USE_ProtoBinDir}
%define protoPrefix /var/tmp/X11R%{X11_Version}-%{X11_Release}/%{TO_ARCH}
%define protoBinDir %{protoPrefix}/bin
%define protoDir %{protoPrefix}%{_prefix}
%define __os_install_post %{nil}
%else
%define protoPrefix %{nil}
%define protoBinDir %{_bindir}
%define protoDir %{_prefix}
%endif

%define _defaultdocdir	%{_prefix}/share/doc
%define _mandir %{_prefix}/man

%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin
%define target_  %{target}-
%define hosttarget --host=%{target}

%define cross_prefix	%{csysdir}%{_prefix}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_sbindir	%{csysdir}%{_sbindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir		%{nil}
%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}
%define hosttarget %{nil}

%endif # !_CROSS

%define docdir		%{_defaultdocdir}/%{name}
# ------------------- description ------------------------------------
%description
The OpenGL Extension Wrangler library
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package devel-shared
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel-shared
These libraries are needed to compile C code.
#-------------------------------
%package devel-static
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel-static
These libraries are needed to compile C code.
#-------------------------------
%package doc
Summary:      doc for %{name}
Group:        Documentation
%description doc
doc for %{name}
#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

sed -i s:"CC = cc":"CC = %{target_}gcc": config/Makefile.linux
sed -i s:"LD = cc":"LD = %{target_}gcc": config/Makefile.linux
sed -i s:"POPT = -O2":"POPT ?= -O2": config/Makefile.linux

tar -xaf %SOURCE2
patch -b -z .orig -p0<patches/makefile.patch

sed -i s:"DIST_DIR ":"# DIST_DIR ": Makefile

# ------------------- Build ------------------------------------------
%Build
CPATH=
%if %{_CROSS}
CPATH="%{csysbindir}:"
export GCC_NoHostPath=d
%endif
%if %{USE_ProtoBinDir}
export LD_LIBRARY_PATH="%{protoPrefix}%{_libdir}"
CPATH="$CPATH%{protoBinDir}:"
%endif
export PATH=$CPATH$PATH:/opt/perl/bin

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i486 -ffast-math -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 -fPIC -fno-asynchronous-unwind-tables"
%endif
%if %{_arch} == "arm"
%if %{_target_cpu} == "armv7l"
OPTFLAGS="-O2 -fPIC -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%else
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif
%endif

CFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections -D_GNU_SOURCE -std=gnu99"

make POPT="$CFLAGS" GLEW_DEST=%{_prefix} \
	INCLUDE="-Iinclude -I%{protoPrefix}%{_includedir}" \
	LDFLAGS.EXTRA="-L%{protoPrefix}%{_libdir}" \
	&>Fmake_log.txt

# ------------------- Install ----------------------------------------
%Install
CPATH=
%if %{_CROSS}
CPATH="%{csysbindir}:"
export GCC_NoHostPath=d
%endif
%if %{USE_ProtoBinDir}
CPATH="$CPATH%{protoBinDir}:"
RPM_TMP_ROOT=$RPM_BUILD_ROOT/tmp
%else   # USE_ProtoBinDir
RPM_TMP_ROOT=$RPM_BUILD_ROOT
%endif
export PATH=$CPATH$PATH:/opt/perl/bin

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_TMP_ROOT%{docdir}

make DESTDIR=$RPM_TMP_ROOT GLEW_DEST=%{_prefix} STRIP= install &>FInstall_log.txt
make DESTDIR=$RPM_TMP_ROOT GLEW_DEST=%{_prefix} STRIP= install.bin >>FInstall_log.txt
cp -a LICENSE.txt README.txt $RPM_TMP_ROOT%{docdir}/
cp -ar doc $RPM_TMP_ROOT%{docdir}/

%if %{USE_ProtoBinDir}
TARGET_PRFIX=%{_prefix}
RPM_TMP_ROOT=$RPM_BUILD_ROOT/tmp
TARGET_INSTDIR=$RPM_BUILD_ROOT%{csysdir}%{_prefix}
TARGET_NAME=%{target_}
TARGET_LIB=%{_lib}
export TARGET_PRFIX RPM_TMP_ROOT TARGET_INSTDIR TARGET_NAME TARGET_LIB

TARGET_ProtoDir=%{protoDir}
TARGET_CrossDir=%{csysdir}%{_prefix}
MKCROSSDIR=%{BUILD_LOCAL_CROSS}
export TARGET_ProtoDir TARGET_CrossDir MKCROSSDIR
%SOURCE1
%endif  # !USE_ProtoBinDir

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-devel-$SE $DD/%{name}-devel-$DE
  mv %{name}-devel-shared-$SE $DD/%{name}-devel-shared-$DE
  mv %{name}-devel-static-$SE $DD/%{name}-devel-static-$DE
  mv %{name}-doc-$SE $DD/%{name}-doc-$DE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
%endif #BUILD_LOCAL_CROSS
popd
 

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%if %{BUILD_LOCAL_CROSS}
  TMP_TO=$DDC/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{TO_ARCH}-%{version}-%{release}.%{_build_cpu}
  mkdir -p $tmp
  cp -r cross $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%endif
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------

%files
%{_bindir}
%{_libdir}/libGLEW.so.*
%{docdir}/LICENSE.txt
%{docdir}/README.txt

%files devel
%{_includedir}
%{_libdir}/pkgconfig

%files devel-shared
%{_libdir}/libGLEW.so

%files devel-static
%{_libdir}/libGLEW.a

%files doc
%{docdir}/doc

# ------------------- Cross Files ------------------------------------
%if %{BUILD_LOCAL_CROSS}

%Files %{TO_ARCH}
%{cross_libdir}
%{cross_includedir}
%{cross_docdir}

%endif #!BUILD_LOCAL_CROSS
